package com.chameth.yaotp.algos

import javax.crypto.Mac
import javax.crypto.spec.SecretKeySpec

private const val HMAC_SHA1_ALGORITHM = "HmacSHA1"

fun hmacSha1(keyMaterial: ByteArray, input: ByteArray): ByteArray {
    return with(Mac.getInstance(HMAC_SHA1_ALGORITHM)) {
        init(getKey(keyMaterial))
        doFinal(input)
    }
}

private fun getKey(material: ByteArray) = SecretKeySpec(material, HMAC_SHA1_ALGORITHM)